#!/usr/bin/python
# -*- coding: utf-8 -*-
# Framework zur Aufgabe "Backtracking"
# DM, 2010-06-22

import os, sys

########################################################
# Sucht den Startpunkt und ruft dann ihre Funktion auf #
# INPUT: Labyrinth                                     #
########################################################
def find_way( lab ):
  # Startpunkt gegeben durch row und column Koordinate, wobei
  # (0,0) sich oben links befindet.
  column = -1
  row = -1
  for i in range(len(lab)):
    if 'S' in lab[i]:
      column = lab[i].index('S')
      row = i
  if column == -1 or row == -1:
    print "Kein Startpunkt gegeben ... EXIT!"
    sys.exit(0)

  # hier rufen Sie jetzt ihre Funktion auf, welche das Labyrinth
  # und den Startpunkt übergeben bekommt
  #
  # wayOut = []
  # finished = False
  #
  # search_way(lab, row, column,  wayOut,  finished)
  #
  # Waere EIN Beispiel fuer den Aufruf.

  ###############################
  ## IHR CODE MUSS HIER STEHEN ##
  ###############################


################################################################################

##############################################
# Gibt das Labyrinth auf der Konsole aus     #
# INPUT: Labyrinth                           #
#                                            #
# Sehr nuetzlich zum Debuggen bzw. verfolgen #
# des Weges                                  #
##############################################
def print_lab(lab):
  for i in range(len(lab)):
    for j in range(len(lab[i])):
      print lab[i][j], 
    print ''

############################
# Gibt das Hilfe-Menue aus #
############################
def show_help():
  print "####################################################################"
  print "#  _               ______     _______  _____ _   _ _______ _    _  #"
  print "# | |        /\   |  _ \ \   / /  __ \|_   _| \ | |__   __| |  | | #"
  print "# | |       /  \  | |_) \ \_/ /| |__) | | | |  \| |  | |  | |__| | #"
  print "# | |      / /\ \ |  _ < \   / |  _  /  | | | . ` |  | |  |  __  | #"
  print "# | |____ / ____ \| |_) | | |  | | \ \ _| |_| |\  |  | |  | |  | | #"
  print "# |______/_/    \_\____/  |_|  |_|  \_\_____|_| \_|  |_|  |_|  |_| #"
  print "####################################################################"
  print ""
  print "Verwendung: python labyrinthFramework.py [OPTIONEN]"
  print "            ./labyrinthFramework.py [OPTIONEN]"
  print ""
  print "Optionen:"
  print "   -h    Ausgabe dieser Hilfe"
  print "   LAB   Uebergabe einer Labyrinth-Datei"
  print ""
  print ""
  print "Labyrinth-Datei:"
  print ""
  print "Aufbau:"
  print "    #    Stellt eine Wand dar, kann nicht betreten oder durchquert werden. Beachten Sie,"
  print "         das um das gesamte Labyrinth eine Mauer gehen muss!"
  print "    S    Stellt den Startpunkt dar (darf nur einmal vorkommen)."
  print "    Z    Stellt den Zielort/Ausgang dar (kann öfters vorkommen, sollte aber"
  print "         aus Testgründen nur einmal vorkommen)."
  print "   ' '   Stellt einen begehbaren Bereich dar."
  print "    ,    Trennt einzelne Bereiche von einander."
  print ""
  print "Beispiel fuer eine Labyrinth-Datei:"  
  print "#,#,#,#,#,#,#,#,#,#,#,#"
  print "#,S,#,Z, , ,#, , , , ,#"
  print "#, , , , , ,#, , ,#, ,#"
  print "#, , , , , , , , , , ,#"
  print "#,#,#,#,#,#,#,#,#,#,#,#"


###################################################
# Wie der Name sagt, die Main Funktion, welche zu # 
# beginn aufgerufen wird                          #
###################################################
def main():
  # default Dateiname
  labyrinthFile = 'labyrinth.txt'
  # Trennsymbol zwichen zwei Elementen im Labyrinth
  delimiter = ','
  # wird von Datei gelesen oder wird das inline Array verwendet
  readFromFile = False
  # das Labyrinth
  myLab = []

  # Anzahl der Kommandozeilen-Parameter werden ueberprueft
  # wird ein Parameter uebergeben, verwende diesen um das Labyrinth
  # aus dieser Datei zu lesen
  if len(sys.argv) >= 2:
    if sys.argv[1] == '-h' or sys.argv[1] == '-H' or sys.argv[1] == '--help' or sys.argv[1] == 'help': 
      show_help()
      sys.exit(0)
    
    # Existiert die Datei ?
    if os.path.exists(sys.argv[1]) and os.path.isfile(sys.argv[1]):
      print "Reading labyrinth from file ... "
      print "Using: ",  sys.argv[1]
      readFromFile = True
      # oeffne die Datei
      fileIn = open( sys.argv[1] )
      # Lese das Labyrinth aus der Datei in unser myLab Array
      for line in fileIn:
        lineClear = line.strip()                # entferne Leezeichen am Anfang und Ende
        lineCutted = lineClear.split(delimiter) # Zerlege die gelesene Zeile
        myLab.append(lineCutted)                # Fuege zerlegte Zeile in das Array ein
    else: 
      print "File '", sys.argv[1] ,"' does not exist! Now using default file."
      if os.path.exists(labyrinthFile) and os.path.isfile(labyrinthFile):
        print "File does not exist ... using default file"
        readFromFile = True
        fileIn = open( labyrinthFile )
        for line in fileIn:
          lineClear = line.strip()                # entferne Leezeichen am Anfang und Ende
          lineCutted = lineClear.split(delimiter) # Zerlege die gelesene Zeile
          myLab.append(lineCutted)                # Fuege zerlegte Zeile in das Array ein
      else:
        print "Default file does not exist!"
        print "Using inline labyrinth"
        # dieses Labyrinth wird verwendet, wenn kein anderes vorhanden ist
        myLab=[['#','#','#','#','#','#','#','#','#','#','#','#'],
              ['#','S','#',' ',' ',' ','#',' ',' ',' ',' ','#'],
              ['#',' ',' ',' ','#','#','#','#','#',' ','#','#'],
              ['#',' ','#',' ',' ',' ','#',' ',' ',' ','#','#'],
              ['#',' ','#','#','#',' ','#',' ','#',' ','#','#'],
              ['#',' ',' ',' ','#',' ',' ',' ','#',' ','#','#'],
              ['#','#','#','#','#',' ','#',' ','#',' ',' ','#'],
              ['#',' ','#',' ','#',' ','#','#','#','#',' ','#'],
              ['#',' ','#',' ',' ',' ','#',' ',' ',' ',' ','#'],
              ['#',' ','#',' ','#','#','#',' ','#','#','#','#'],
              ['#',' ',' ',' ',' ',' ','#',' ',' ',' ','Z','#'],
              ['#','#','#','#','#','#','#','#','#','#','#','#']]
  else:
    if os.path.exists(labyrinthFile) and os.path.isfile(labyrinthFile):
      print "Using default file"
      readFromFile = True
      fileIn = open( labyrinthFile )
      for line in fileIn:
        lineClear = line.strip()                # entferne Leezeichen am Anfang und Ende
        lineCutted = lineClear.split(delimiter) # Zerlege die gelesene Zeile
        myLab.append(lineCutted)                # Fuege zerlegte Zeile in das Array ein
    else:
      print "Default file does not exist!"
      print "Default file does not exist!"
      print "Using inline labyrinth"
      # dieses Labyrinth wird verwendet, wenn kein anderes vorhanden ist
      myLab=[['#','#','#','#','#','#','#','#','#','#','#','#'],
            ['#','S','#',' ',' ',' ','#',' ',' ',' ',' ','#'],
            ['#',' ',' ',' ','#','#','#','#','#',' ','#','#'],
            ['#',' ','#',' ',' ',' ','#',' ',' ',' ','#','#'],
            ['#',' ','#','#','#',' ','#',' ','#',' ','#','#'],
            ['#',' ',' ',' ','#',' ',' ',' ','#',' ','#','#'],
            ['#','#','#','#','#',' ','#',' ','#',' ',' ','#'],
            ['#',' ','#',' ','#',' ','#','#','#','#',' ','#'],
            ['#',' ','#',' ',' ',' ','#',' ',' ',' ',' ','#'],
            ['#',' ','#',' ','#','#','#',' ','#','#','#','#'],
            ['#',' ',' ',' ',' ',' ','#',' ',' ',' ','Z','#'],
            ['#','#','#','#','#','#','#','#','#','#','#','#']]

  find_way(myLab)

#########################
# calling main function #
#########################
if __name__=="__main__":
  main();
